Index: pacemaker/pengine/test10/master-9.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-9.exp
+++ pacemaker/pengine/test10/master-9.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="45" operation="stop" operation_key="child_DoFencing:1_stop_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_timeout="20000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_timeout="20000"  hostlist="sgi2 ibm1 va1 test02 "/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
      <action_set>
       <rsc_op id="13" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -37,7 +37,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -46,7 +46,7 @@
      <action_set>
       <rsc_op id="14" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="child_DoFencing:3" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -55,7 +55,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="child_DoFencing:3" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="sgi2 ibm1 va1 test02 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -87,7 +87,7 @@
      <action_set>
       <rsc_op id="15" operation="monitor" operation_key="ocf_msdummy:2_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:2" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -96,7 +96,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="ocf_msdummy:2_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:2" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -105,7 +105,7 @@
      <action_set>
       <rsc_op id="16" operation="monitor" operation_key="ocf_msdummy:3_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:3" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -114,7 +114,7 @@
      <action_set>
       <rsc_op id="7" operation="monitor" operation_key="ocf_msdummy:3_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:3" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -123,7 +123,7 @@
      <action_set>
       <rsc_op id="17" operation="monitor" operation_key="ocf_msdummy:4_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:4" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="4" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="4" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -132,7 +132,7 @@
      <action_set>
       <rsc_op id="8" operation="monitor" operation_key="ocf_msdummy:4_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:4" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="4" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="4" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -141,7 +141,7 @@
      <action_set>
       <rsc_op id="18" operation="monitor" operation_key="ocf_msdummy:5_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:5" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="5" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="5" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -150,7 +150,7 @@
      <action_set>
       <rsc_op id="9" operation="monitor" operation_key="ocf_msdummy:5_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:5" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="5" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="5" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -159,7 +159,7 @@
      <action_set>
       <rsc_op id="19" operation="monitor" operation_key="ocf_msdummy:6_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:6" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="6" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="6" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -168,7 +168,7 @@
      <action_set>
       <rsc_op id="10" operation="monitor" operation_key="ocf_msdummy:6_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:6" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="6" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="6" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -177,7 +177,7 @@
      <action_set>
       <rsc_op id="20" operation="monitor" operation_key="ocf_msdummy:7_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b">
         <primitive id="ocf_msdummy:7" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="7" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="7" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="va1" CRM_meta_on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -186,7 +186,7 @@
      <action_set>
       <rsc_op id="11" operation="monitor" operation_key="ocf_msdummy:7_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
         <primitive id="ocf_msdummy:7" class="ocf" provider="heartbeat" type="/usr/lib64/heartbeat/cts/OCFMSDummy"/>
-        <attributes CRM_meta_clone="7" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
+        <attributes CRM_meta_clone="7" CRM_meta_clone_max="8" CRM_meta_clone_node_max="2" CRM_meta_globally_unique="true" CRM_meta_master_max="4" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_target_rc="7" CRM_meta_timeout="10000"  logfile="/var/log/cts_ocfdummy.log"/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -194,7 +194,7 @@
    <synapse id="20">
      <action_set>
       <crm_event id="63" operation="do_shutdown" operation_key="do_shutdown-ibm1" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="ibm1" CRM_meta_on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
         </downed>
Index: pacemaker/pengine/test10/master-asymmetrical-order.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-asymmetrical-order.exp
+++ pacemaker/pengine/test10/master-asymmetrical-order.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="3" operation="stop" operation_key="rsc1:0_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" long-id="rsc1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="2" operation="demote" operation_key="rsc1:0_demote_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" long-id="rsc1:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -32,7 +32,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="rsc1:1_stop_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" long-id="rsc1:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/master-colocation.exp
===================================================================
--- pacemaker.orig/pengine/test10/master-colocation.exp
+++ pacemaker/pengine/test10/master-colocation.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="conntrackd-stateful:0_monitor_29000" on_node="box1" on_node_uuid="box1">
         <primitive id="conntrackd-stateful" long-id="conntrackd-stateful:0" class="ocf" provider="dk" type="conn"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="29000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_role="Slave" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="29000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="box1" CRM_meta_on_node_uuid="box1" CRM_meta_role="Slave" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="conntrackd-stateful:1_monitor_30000" on_node="box2" on_node_uuid="box2">
         <primitive id="conntrackd-stateful" long-id="conntrackd-stateful:1" class="ocf" provider="dk" type="conn"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="30000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="30000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="box2" CRM_meta_on_node_uuid="box2" CRM_meta_op_target_rc="8" CRM_meta_role="Master" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -25,7 +25,7 @@
     <action_set>
       <rsc_op id="10" operation="promote" operation_key="conntrackd-stateful:1_promote_0" on_node="box2" on_node_uuid="box2">
         <primitive id="conntrackd-stateful" long-id="conntrackd-stateful:1" class="ocf" provider="dk" type="conn"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="box2" CRM_meta_on_node_uuid="box2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
